t7003: add test to filter a branch with a commit at epoch
[git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset EMAIL
47 unset $(perl -e '
48         my @env = keys %ENV;
49         my $ok = join("|", qw(
50                 TRACE
51                 DEBUG
52                 USE_LOOKUP
53                 TEST
54                 .*_TEST
55                 PROVE
56                 VALGRIND
57         ));
58         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
59         print join("\n", @vars);
60 ')
61 GIT_AUTHOR_EMAIL=author@example.com
62 GIT_AUTHOR_NAME='A U Thor'
63 GIT_COMMITTER_EMAIL=committer@example.com
64 GIT_COMMITTER_NAME='C O Mitter'
65 GIT_MERGE_VERBOSITY=5
66 export GIT_MERGE_VERBOSITY
67 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
69 export EDITOR
70
71 # Protect ourselves from common misconfiguration to export
72 # CDPATH into the environment
73 unset CDPATH
74
75 unset GREP_OPTIONS
76
77 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
78         1|2|true)
79                 echo "* warning: Some tests will not work if GIT_TRACE" \
80                         "is set as to trace on STDERR ! *"
81                 echo "* warning: Please set GIT_TRACE to something" \
82                         "other than 1, 2 or true ! *"
83                 ;;
84 esac
85
86 # Convenience
87 #
88 # A regexp to match 5 and 40 hexdigits
89 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
91
92 # Zero SHA-1
93 _z40=0000000000000000000000000000000000000000
94
95 # Line feed
96 LF='
97 '
98
99 # Each test should start with something like this, after copyright notices:
100 #
101 # test_description='Description of this test...
102 # This test checks if command xyzzy does the right thing...
103 # '
104 # . ./test-lib.sh
105 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
106                 TERM=$ORIGINAL_TERM &&
107                 export TERM &&
108                 [ -t 1 ] &&
109                 tput bold >/dev/null 2>&1 &&
110                 tput setaf 1 >/dev/null 2>&1 &&
111                 tput sgr0 >/dev/null 2>&1
112         ) &&
113         color=t
114
115 while test "$#" -ne 0
116 do
117         case "$1" in
118         -d|--d|--de|--deb|--debu|--debug)
119                 debug=t; shift ;;
120         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
121                 immediate=t; shift ;;
122         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
123                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
124         -h|--h|--he|--hel|--help)
125                 help=t; shift ;;
126         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
127                 verbose=t; shift ;;
128         -q|--q|--qu|--qui|--quie|--quiet)
129                 # Ignore --quiet under a TAP::Harness. Saying how many tests
130                 # passed without the ok/not ok details is always an error.
131                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
132         --with-dashes)
133                 with_dashes=t; shift ;;
134         --no-color)
135                 color=; shift ;;
136         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
137                 valgrind=t; verbose=t; shift ;;
138         --tee)
139                 shift ;; # was handled already
140         --root=*)
141                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
142                 shift ;;
143         *)
144                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
145         esac
146 done
147
148 if test -n "$color"; then
149         say_color () {
150                 (
151                 TERM=$ORIGINAL_TERM
152                 export TERM
153                 case "$1" in
154                         error) tput bold; tput setaf 1;; # bold red
155                         skip)  tput bold; tput setaf 2;; # bold green
156                         pass)  tput setaf 2;;            # green
157                         info)  tput setaf 3;;            # brown
158                         *) test -n "$quiet" && return;;
159                 esac
160                 shift
161                 printf "%s" "$*"
162                 tput sgr0
163                 echo
164                 )
165         }
166 else
167         say_color() {
168                 test -z "$1" && test -n "$quiet" && return
169                 shift
170                 echo "$*"
171         }
172 fi
173
174 error () {
175         say_color error "error: $*"
176         GIT_EXIT_OK=t
177         exit 1
178 }
179
180 say () {
181         say_color info "$*"
182 }
183
184 test "${test_description}" != "" ||
185 error "Test script did not set test_description."
186
187 if test "$help" = "t"
188 then
189         echo "$test_description"
190         exit 0
191 fi
192
193 exec 5>&1
194 if test "$verbose" = "t"
195 then
196         exec 4>&2 3>&1
197 else
198         exec 4>/dev/null 3>/dev/null
199 fi
200
201 test_failure=0
202 test_count=0
203 test_fixed=0
204 test_broken=0
205 test_success=0
206
207 test_external_has_tap=0
208
209 die () {
210         code=$?
211         if test -n "$GIT_EXIT_OK"
212         then
213                 exit $code
214         else
215                 echo >&5 "FATAL: Unexpected exit with code $code"
216                 exit 1
217         fi
218 }
219
220 GIT_EXIT_OK=
221 trap 'die' EXIT
222
223 # The semantics of the editor variables are that of invoking
224 # sh -c "$EDITOR \"$@\"" files ...
225 #
226 # If our trash directory contains shell metacharacters, they will be
227 # interpreted if we just set $EDITOR directly, so do a little dance with
228 # environment variables to work around this.
229 #
230 # In particular, quoting isn't enough, as the path may contain the same quote
231 # that we're using.
232 test_set_editor () {
233         FAKE_EDITOR="$1"
234         export FAKE_EDITOR
235         EDITOR='"$FAKE_EDITOR"'
236         export EDITOR
237 }
238
239 test_decode_color () {
240         awk '
241                 function name(n) {
242                         if (n == 0) return "RESET";
243                         if (n == 1) return "BOLD";
244                         if (n == 30) return "BLACK";
245                         if (n == 31) return "RED";
246                         if (n == 32) return "GREEN";
247                         if (n == 33) return "YELLOW";
248                         if (n == 34) return "BLUE";
249                         if (n == 35) return "MAGENTA";
250                         if (n == 36) return "CYAN";
251                         if (n == 37) return "WHITE";
252                         if (n == 40) return "BLACK";
253                         if (n == 41) return "BRED";
254                         if (n == 42) return "BGREEN";
255                         if (n == 43) return "BYELLOW";
256                         if (n == 44) return "BBLUE";
257                         if (n == 45) return "BMAGENTA";
258                         if (n == 46) return "BCYAN";
259                         if (n == 47) return "BWHITE";
260                 }
261                 {
262                         while (match($0, /\033\[[0-9;]*m/) != 0) {
263                                 printf "%s<", substr($0, 1, RSTART-1);
264                                 codes = substr($0, RSTART+2, RLENGTH-3);
265                                 if (length(codes) == 0)
266                                         printf "%s", name(0)
267                                 else {
268                                         n = split(codes, ary, ";");
269                                         sep = "";
270                                         for (i = 1; i <= n; i++) {
271                                                 printf "%s%s", sep, name(ary[i]);
272                                                 sep = ";"
273                                         }
274                                 }
275                                 printf ">";
276                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
277                         }
278                         print
279                 }
280         '
281 }
282
283 nul_to_q () {
284         perl -pe 'y/\000/Q/'
285 }
286
287 q_to_nul () {
288         perl -pe 'y/Q/\000/'
289 }
290
291 q_to_cr () {
292         tr Q '\015'
293 }
294
295 q_to_tab () {
296         tr Q '\011'
297 }
298
299 append_cr () {
300         sed -e 's/$/Q/' | tr Q '\015'
301 }
302
303 remove_cr () {
304         tr '\015' Q | sed -e 's/Q$//'
305 }
306
307 # In some bourne shell implementations, the "unset" builtin returns
308 # nonzero status when a variable to be unset was not set in the first
309 # place.
310 #
311 # Use sane_unset when that should not be considered an error.
312
313 sane_unset () {
314         unset "$@"
315         return 0
316 }
317
318 test_tick () {
319         if test -z "${test_tick+set}"
320         then
321                 test_tick=1112911993
322         else
323                 test_tick=$(($test_tick + 60))
324         fi
325         GIT_COMMITTER_DATE="$test_tick -0700"
326         GIT_AUTHOR_DATE="$test_tick -0700"
327         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
328 }
329
330 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
331 #
332 # This will commit a file with the given contents and the given commit
333 # message.  It will also add a tag with <message> as name.
334 #
335 # Both <file> and <contents> default to <message>.
336
337 test_commit () {
338         notick= &&
339         if test "z$1" = "z--notick"
340         then
341                 notick=yes
342                 shift
343         fi &&
344         file=${2:-"$1.t"} &&
345         echo "${3-$1}" > "$file" &&
346         git add "$file" &&
347         if test -z "$notick"
348         then
349                 test_tick
350         fi &&
351         git commit -m "$1" &&
352         git tag "$1"
353 }
354
355 # Call test_merge with the arguments "<message> <commit>", where <commit>
356 # can be a tag pointing to the commit-to-merge.
357
358 test_merge () {
359         test_tick &&
360         git merge -m "$1" "$2" &&
361         git tag "$1"
362 }
363
364 # This function helps systems where core.filemode=false is set.
365 # Use it instead of plain 'chmod +x' to set or unset the executable bit
366 # of a file in the working directory and add it to the index.
367
368 test_chmod () {
369         chmod "$@" &&
370         git update-index --add "--chmod=$@"
371 }
372
373 # Unset a configuration variable, but don't fail if it doesn't exist.
374 test_unconfig () {
375         git config --unset-all "$@"
376         config_status=$?
377         case "$config_status" in
378         5) # ok, nothing to unset
379                 config_status=0
380                 ;;
381         esac
382         return $config_status
383 }
384
385 # Set git config, automatically unsetting it after the test is over.
386 test_config () {
387         test_when_finished "test_unconfig '$1'" &&
388         git config "$@"
389 }
390
391 # Use test_set_prereq to tell that a particular prerequisite is available.
392 # The prerequisite can later be checked for in two ways:
393 #
394 # - Explicitly using test_have_prereq.
395 #
396 # - Implicitly by specifying the prerequisite tag in the calls to
397 #   test_expect_{success,failure,code}.
398 #
399 # The single parameter is the prerequisite tag (a simple word, in all
400 # capital letters by convention).
401
402 test_set_prereq () {
403         satisfied="$satisfied$1 "
404 }
405 satisfied=" "
406
407 test_have_prereq () {
408         # prerequisites can be concatenated with ','
409         save_IFS=$IFS
410         IFS=,
411         set -- $*
412         IFS=$save_IFS
413
414         total_prereq=0
415         ok_prereq=0
416         missing_prereq=
417
418         for prerequisite
419         do
420                 total_prereq=$(($total_prereq + 1))
421                 case $satisfied in
422                 *" $prerequisite "*)
423                         ok_prereq=$(($ok_prereq + 1))
424                         ;;
425                 *)
426                         # Keep a list of missing prerequisites
427                         if test -z "$missing_prereq"
428                         then
429                                 missing_prereq=$prerequisite
430                         else
431                                 missing_prereq="$prerequisite,$missing_prereq"
432                         fi
433                 esac
434         done
435
436         test $total_prereq = $ok_prereq
437 }
438
439 test_declared_prereq () {
440         case ",$test_prereq," in
441         *,$1,*)
442                 return 0
443                 ;;
444         esac
445         return 1
446 }
447
448 # You are not expected to call test_ok_ and test_failure_ directly, use
449 # the text_expect_* functions instead.
450
451 test_ok_ () {
452         test_success=$(($test_success + 1))
453         say_color "" "ok $test_count - $@"
454 }
455
456 test_failure_ () {
457         test_failure=$(($test_failure + 1))
458         say_color error "not ok - $test_count $1"
459         shift
460         echo "$@" | sed -e 's/^/#       /'
461         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
462 }
463
464 test_known_broken_ok_ () {
465         test_fixed=$(($test_fixed+1))
466         say_color "" "ok $test_count - $@ # TODO known breakage"
467 }
468
469 test_known_broken_failure_ () {
470         test_broken=$(($test_broken+1))
471         say_color skip "not ok $test_count - $@ # TODO known breakage"
472 }
473
474 test_debug () {
475         test "$debug" = "" || eval "$1"
476 }
477
478 test_eval_ () {
479         # This is a separate function because some tests use
480         # "return" to end a test_expect_success block early.
481         eval >&3 2>&4 "$*"
482 }
483
484 test_run_ () {
485         test_cleanup=:
486         expecting_failure=$2
487         test_eval_ "$1"
488         eval_ret=$?
489
490         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
491         then
492                 test_eval_ "$test_cleanup"
493         fi
494         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
495                 echo ""
496         fi
497         return "$eval_ret"
498 }
499
500 test_skip () {
501         test_count=$(($test_count+1))
502         to_skip=
503         for skp in $GIT_SKIP_TESTS
504         do
505                 case $this_test.$test_count in
506                 $skp)
507                         to_skip=t
508                         break
509                 esac
510         done
511         if test -z "$to_skip" && test -n "$test_prereq" &&
512            ! test_have_prereq "$test_prereq"
513         then
514                 to_skip=t
515         fi
516         case "$to_skip" in
517         t)
518                 of_prereq=
519                 if test "$missing_prereq" != "$test_prereq"
520                 then
521                         of_prereq=" of $test_prereq"
522                 fi
523
524                 say_color skip >&3 "skipping test: $@"
525                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
526                 : true
527                 ;;
528         *)
529                 false
530                 ;;
531         esac
532 }
533
534 test_expect_failure () {
535         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
536         test "$#" = 2 ||
537         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
538         export test_prereq
539         if ! test_skip "$@"
540         then
541                 say >&3 "checking known breakage: $2"
542                 if test_run_ "$2" expecting_failure
543                 then
544                         test_known_broken_ok_ "$1"
545                 else
546                         test_known_broken_failure_ "$1"
547                 fi
548         fi
549         echo >&3 ""
550 }
551
552 test_expect_success () {
553         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
554         test "$#" = 2 ||
555         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
556         export test_prereq
557         if ! test_skip "$@"
558         then
559                 say >&3 "expecting success: $2"
560                 if test_run_ "$2"
561                 then
562                         test_ok_ "$1"
563                 else
564                         test_failure_ "$@"
565                 fi
566         fi
567         echo >&3 ""
568 }
569
570 # test_external runs external test scripts that provide continuous
571 # test output about their progress, and succeeds/fails on
572 # zero/non-zero exit code.  It outputs the test output on stdout even
573 # in non-verbose mode, and announces the external script with "# run
574 # <n>: ..." before running it.  When providing relative paths, keep in
575 # mind that all scripts run in "trash directory".
576 # Usage: test_external description command arguments...
577 # Example: test_external 'Perl API' perl ../path/to/test.pl
578 test_external () {
579         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
580         test "$#" = 3 ||
581         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
582         descr="$1"
583         shift
584         export test_prereq
585         if ! test_skip "$descr" "$@"
586         then
587                 # Announce the script to reduce confusion about the
588                 # test output that follows.
589                 say_color "" "# run $test_count: $descr ($*)"
590                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
591                 # to be able to use them in script
592                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
593                 # Run command; redirect its stderr to &4 as in
594                 # test_run_, but keep its stdout on our stdout even in
595                 # non-verbose mode.
596                 "$@" 2>&4
597                 if [ "$?" = 0 ]
598                 then
599                         if test $test_external_has_tap -eq 0; then
600                                 test_ok_ "$descr"
601                         else
602                                 say_color "" "# test_external test $descr was ok"
603                                 test_success=$(($test_success + 1))
604                         fi
605                 else
606                         if test $test_external_has_tap -eq 0; then
607                                 test_failure_ "$descr" "$@"
608                         else
609                                 say_color error "# test_external test $descr failed: $@"
610                                 test_failure=$(($test_failure + 1))
611                         fi
612                 fi
613         fi
614 }
615
616 # Like test_external, but in addition tests that the command generated
617 # no output on stderr.
618 test_external_without_stderr () {
619         # The temporary file has no (and must have no) security
620         # implications.
621         tmp=${TMPDIR:-/tmp}
622         stderr="$tmp/git-external-stderr.$$.tmp"
623         test_external "$@" 4> "$stderr"
624         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
625         descr="no stderr: $1"
626         shift
627         say >&3 "# expecting no stderr from previous command"
628         if [ ! -s "$stderr" ]; then
629                 rm "$stderr"
630
631                 if test $test_external_has_tap -eq 0; then
632                         test_ok_ "$descr"
633                 else
634                         say_color "" "# test_external_without_stderr test $descr was ok"
635                         test_success=$(($test_success + 1))
636                 fi
637         else
638                 if [ "$verbose" = t ]; then
639                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
640                 else
641                         output=
642                 fi
643                 # rm first in case test_failure exits.
644                 rm "$stderr"
645                 if test $test_external_has_tap -eq 0; then
646                         test_failure_ "$descr" "$@" "$output"
647                 else
648                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
649                         test_failure=$(($test_failure + 1))
650                 fi
651         fi
652 }
653
654 # debugging-friendly alternatives to "test [-f|-d|-e]"
655 # The commands test the existence or non-existence of $1. $2 can be
656 # given to provide a more precise diagnosis.
657 test_path_is_file () {
658         if ! [ -f "$1" ]
659         then
660                 echo "File $1 doesn't exist. $*"
661                 false
662         fi
663 }
664
665 test_path_is_dir () {
666         if ! [ -d "$1" ]
667         then
668                 echo "Directory $1 doesn't exist. $*"
669                 false
670         fi
671 }
672
673 test_path_is_missing () {
674         if [ -e "$1" ]
675         then
676                 echo "Path exists:"
677                 ls -ld "$1"
678                 if [ $# -ge 1 ]; then
679                         echo "$*"
680                 fi
681                 false
682         fi
683 }
684
685 # test_line_count checks that a file has the number of lines it
686 # ought to. For example:
687 #
688 #       test_expect_success 'produce exactly one line of output' '
689 #               do something >output &&
690 #               test_line_count = 1 output
691 #       '
692 #
693 # is like "test $(wc -l <output) = 1" except that it passes the
694 # output through when the number of lines is wrong.
695
696 test_line_count () {
697         if test $# != 3
698         then
699                 error "bug in the test script: not 3 parameters to test_line_count"
700         elif ! test $(wc -l <"$3") "$1" "$2"
701         then
702                 echo "test_line_count: line count for $3 !$1 $2"
703                 cat "$3"
704                 return 1
705         fi
706 }
707
708 # This is not among top-level (test_expect_success | test_expect_failure)
709 # but is a prefix that can be used in the test script, like:
710 #
711 #       test_expect_success 'complain and die' '
712 #           do something &&
713 #           do something else &&
714 #           test_must_fail git checkout ../outerspace
715 #       '
716 #
717 # Writing this as "! git checkout ../outerspace" is wrong, because
718 # the failure could be due to a segv.  We want a controlled failure.
719
720 test_must_fail () {
721         "$@"
722         exit_code=$?
723         if test $exit_code = 0; then
724                 echo >&2 "test_must_fail: command succeeded: $*"
725                 return 1
726         elif test $exit_code -gt 129 -a $exit_code -le 192; then
727                 echo >&2 "test_must_fail: died by signal: $*"
728                 return 1
729         elif test $exit_code = 127; then
730                 echo >&2 "test_must_fail: command not found: $*"
731                 return 1
732         fi
733         return 0
734 }
735
736 # Similar to test_must_fail, but tolerates success, too.  This is
737 # meant to be used in contexts like:
738 #
739 #       test_expect_success 'some command works without configuration' '
740 #               test_might_fail git config --unset all.configuration &&
741 #               do something
742 #       '
743 #
744 # Writing "git config --unset all.configuration || :" would be wrong,
745 # because we want to notice if it fails due to segv.
746
747 test_might_fail () {
748         "$@"
749         exit_code=$?
750         if test $exit_code -gt 129 -a $exit_code -le 192; then
751                 echo >&2 "test_might_fail: died by signal: $*"
752                 return 1
753         elif test $exit_code = 127; then
754                 echo >&2 "test_might_fail: command not found: $*"
755                 return 1
756         fi
757         return 0
758 }
759
760 # Similar to test_must_fail and test_might_fail, but check that a
761 # given command exited with a given exit code. Meant to be used as:
762 #
763 #       test_expect_success 'Merge with d/f conflicts' '
764 #               test_expect_code 1 git merge "merge msg" B master
765 #       '
766
767 test_expect_code () {
768         want_code=$1
769         shift
770         "$@"
771         exit_code=$?
772         if test $exit_code = $want_code
773         then
774                 return 0
775         fi
776
777         echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
778         return 1
779 }
780
781 # test_cmp is a helper function to compare actual and expected output.
782 # You can use it like:
783 #
784 #       test_expect_success 'foo works' '
785 #               echo expected >expected &&
786 #               foo >actual &&
787 #               test_cmp expected actual
788 #       '
789 #
790 # This could be written as either "cmp" or "diff -u", but:
791 # - cmp's output is not nearly as easy to read as diff -u
792 # - not all diff versions understand "-u"
793
794 test_cmp() {
795         $GIT_TEST_CMP "$@"
796 }
797
798 # This function can be used to schedule some commands to be run
799 # unconditionally at the end of the test to restore sanity:
800 #
801 #       test_expect_success 'test core.capslock' '
802 #               git config core.capslock true &&
803 #               test_when_finished "git config --unset core.capslock" &&
804 #               hello world
805 #       '
806 #
807 # That would be roughly equivalent to
808 #
809 #       test_expect_success 'test core.capslock' '
810 #               git config core.capslock true &&
811 #               hello world
812 #               git config --unset core.capslock
813 #       '
814 #
815 # except that the greeting and config --unset must both succeed for
816 # the test to pass.
817 #
818 # Note that under --immediate mode, no clean-up is done to help diagnose
819 # what went wrong.
820
821 test_when_finished () {
822         test_cleanup="{ $*
823                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
824 }
825
826 # Most tests can use the created repository, but some may need to create more.
827 # Usage: test_create_repo <directory>
828 test_create_repo () {
829         test "$#" = 1 ||
830         error "bug in the test script: not 1 parameter to test-create-repo"
831         repo="$1"
832         mkdir -p "$repo"
833         (
834                 cd "$repo" || error "Cannot setup test environment"
835                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
836                 error "cannot run git init -- have you built things yet?"
837                 mv .git/hooks .git/hooks-disabled
838         ) || exit
839 }
840
841 test_done () {
842         GIT_EXIT_OK=t
843
844         if test -z "$HARNESS_ACTIVE"; then
845                 test_results_dir="$TEST_DIRECTORY/test-results"
846                 mkdir -p "$test_results_dir"
847                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
848
849                 cat >>"$test_results_path" <<-EOF
850                 total $test_count
851                 success $test_success
852                 fixed $test_fixed
853                 broken $test_broken
854                 failed $test_failure
855
856                 EOF
857         fi
858
859         if test "$test_fixed" != 0
860         then
861                 say_color pass "# fixed $test_fixed known breakage(s)"
862         fi
863         if test "$test_broken" != 0
864         then
865                 say_color error "# still have $test_broken known breakage(s)"
866                 msg="remaining $(($test_count-$test_broken)) test(s)"
867         else
868                 msg="$test_count test(s)"
869         fi
870         case "$test_failure" in
871         0)
872                 # Maybe print SKIP message
873                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
874
875                 if test $test_external_has_tap -eq 0; then
876                         say_color pass "# passed all $msg"
877                         say "1..$test_count$skip_all"
878                 fi
879
880                 test -d "$remove_trash" &&
881                 cd "$(dirname "$remove_trash")" &&
882                 rm -rf "$(basename "$remove_trash")"
883
884                 exit 0 ;;
885
886         *)
887                 if test $test_external_has_tap -eq 0; then
888                         say_color error "# failed $test_failure among $msg"
889                         say "1..$test_count"
890                 fi
891
892                 exit 1 ;;
893
894         esac
895 }
896
897 # Test the binaries we have just built.  The tests are kept in
898 # t/ subdirectory and are run in 'trash directory' subdirectory.
899 if test -z "$TEST_DIRECTORY"
900 then
901         # We allow tests to override this, in case they want to run tests
902         # outside of t/, e.g. for running tests on the test library
903         # itself.
904         TEST_DIRECTORY=$(pwd)
905 fi
906 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
907
908 if test -n "$valgrind"
909 then
910         make_symlink () {
911                 test -h "$2" &&
912                 test "$1" = "$(readlink "$2")" || {
913                         # be super paranoid
914                         if mkdir "$2".lock
915                         then
916                                 rm -f "$2" &&
917                                 ln -s "$1" "$2" &&
918                                 rm -r "$2".lock
919                         else
920                                 while test -d "$2".lock
921                                 do
922                                         say "Waiting for lock on $2."
923                                         sleep 1
924                                 done
925                         fi
926                 }
927         }
928
929         make_valgrind_symlink () {
930                 # handle only executables, unless they are shell libraries that
931                 # need to be in the exec-path.  We will just use "#!" as a
932                 # guess for a shell-script, since we have no idea what the user
933                 # may have configured as the shell path.
934                 test -x "$1" ||
935                 test "#!" = "$(head -c 2 <"$1")" ||
936                 return;
937
938                 base=$(basename "$1")
939                 symlink_target=$GIT_BUILD_DIR/$base
940                 # do not override scripts
941                 if test -x "$symlink_target" &&
942                     test ! -d "$symlink_target" &&
943                     test "#!" != "$(head -c 2 < "$symlink_target")"
944                 then
945                         symlink_target=../valgrind.sh
946                 fi
947                 case "$base" in
948                 *.sh|*.perl)
949                         symlink_target=../unprocessed-script
950                 esac
951                 # create the link, or replace it if it is out of date
952                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
953         }
954
955         # override all git executables in TEST_DIRECTORY/..
956         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
957         mkdir -p "$GIT_VALGRIND"/bin
958         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
959         do
960                 make_valgrind_symlink $file
961         done
962         OLDIFS=$IFS
963         IFS=:
964         for path in $PATH
965         do
966                 ls "$path"/git-* 2> /dev/null |
967                 while read file
968                 do
969                         make_valgrind_symlink "$file"
970                 done
971         done
972         IFS=$OLDIFS
973         PATH=$GIT_VALGRIND/bin:$PATH
974         GIT_EXEC_PATH=$GIT_VALGRIND/bin
975         export GIT_VALGRIND
976 elif test -n "$GIT_TEST_INSTALLED" ; then
977         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
978         error "Cannot run git from $GIT_TEST_INSTALLED."
979         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
980         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
981 else # normal case, use ../bin-wrappers only unless $with_dashes:
982         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
983         if ! test -x "$git_bin_dir/git" ; then
984                 if test -z "$with_dashes" ; then
985                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
986                 fi
987                 with_dashes=t
988         fi
989         PATH="$git_bin_dir:$PATH"
990         GIT_EXEC_PATH=$GIT_BUILD_DIR
991         if test -n "$with_dashes" ; then
992                 PATH="$GIT_BUILD_DIR:$PATH"
993         fi
994 fi
995 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
996 unset GIT_CONFIG
997 GIT_CONFIG_NOSYSTEM=1
998 GIT_ATTR_NOSYSTEM=1
999 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1000
1001 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1002
1003 if test -z "$GIT_TEST_CMP"
1004 then
1005         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1006         then
1007                 GIT_TEST_CMP="$DIFF -c"
1008         else
1009                 GIT_TEST_CMP="$DIFF -u"
1010         fi
1011 fi
1012
1013 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1014 export GITPERLLIB
1015 test -d "$GIT_BUILD_DIR"/templates/blt || {
1016         error "You haven't built things yet, have you?"
1017 }
1018
1019 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1020 then
1021         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1022         export GITPYTHONLIB
1023         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1024                 error "You haven't built git_remote_helpers yet, have you?"
1025         }
1026 fi
1027
1028 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1029         echo >&2 'You need to build test-chmtime:'
1030         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1031         exit 1
1032 fi
1033
1034 # Test repository
1035 test="trash directory.$(basename "$0" .sh)"
1036 test -n "$root" && test="$root/$test"
1037 case "$test" in
1038 /*) TRASH_DIRECTORY="$test" ;;
1039  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1040 esac
1041 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1042 rm -fr "$test" || {
1043         GIT_EXIT_OK=t
1044         echo >&5 "FATAL: Cannot prepare test area"
1045         exit 1
1046 }
1047
1048 HOME="$TRASH_DIRECTORY"
1049 export HOME
1050
1051 test_create_repo "$test"
1052 # Use -P to resolve symlinks in our working directory so that the cwd
1053 # in subprocesses like git equals our $PWD (for pathname comparisons).
1054 cd -P "$test" || exit 1
1055
1056 this_test=${0##*/}
1057 this_test=${this_test%%-*}
1058 for skp in $GIT_SKIP_TESTS
1059 do
1060         case "$this_test" in
1061         $skp)
1062                 say_color skip >&3 "skipping test $this_test altogether"
1063                 skip_all="skip all tests in $this_test"
1064                 test_done
1065         esac
1066 done
1067
1068 # Provide an implementation of the 'yes' utility
1069 yes () {
1070         if test $# = 0
1071         then
1072                 y=y
1073         else
1074                 y="$*"
1075         fi
1076
1077         while echo "$y"
1078         do
1079                 :
1080         done
1081 }
1082
1083 # Fix some commands on Windows
1084 case $(uname -s) in
1085 *MINGW*)
1086         # Windows has its own (incompatible) sort and find
1087         sort () {
1088                 /usr/bin/sort "$@"
1089         }
1090         find () {
1091                 /usr/bin/find "$@"
1092         }
1093         sum () {
1094                 md5sum "$@"
1095         }
1096         # git sees Windows-style pwd
1097         pwd () {
1098                 builtin pwd -W
1099         }
1100         # no POSIX permissions
1101         # backslashes in pathspec are converted to '/'
1102         # exec does not inherit the PID
1103         test_set_prereq MINGW
1104         test_set_prereq SED_STRIPS_CR
1105         ;;
1106 *CYGWIN*)
1107         test_set_prereq POSIXPERM
1108         test_set_prereq EXECKEEPSPID
1109         test_set_prereq NOT_MINGW
1110         test_set_prereq SED_STRIPS_CR
1111         ;;
1112 *)
1113         test_set_prereq POSIXPERM
1114         test_set_prereq BSLASHPSPEC
1115         test_set_prereq EXECKEEPSPID
1116         test_set_prereq NOT_MINGW
1117         ;;
1118 esac
1119
1120 test -z "$NO_PERL" && test_set_prereq PERL
1121 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1122 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1123
1124 # Can we rely on git's output in the C locale?
1125 if test -n "$GETTEXT_POISON"
1126 then
1127         GIT_GETTEXT_POISON=YesPlease
1128         export GIT_GETTEXT_POISON
1129 else
1130         test_set_prereq C_LOCALE_OUTPUT
1131 fi
1132
1133 # Use this instead of test_cmp to compare files that contain expected and
1134 # actual output from git commands that can be translated.  When running
1135 # under GETTEXT_POISON this pretends that the command produced expected
1136 # results.
1137 test_i18ncmp () {
1138         test -n "$GETTEXT_POISON" || test_cmp "$@"
1139 }
1140
1141 # Use this instead of "grep expected-string actual" to see if the
1142 # output from a git command that can be translated either contains an
1143 # expected string, or does not contain an unwanted one.  When running
1144 # under GETTEXT_POISON this pretends that the command produced expected
1145 # results.
1146 test_i18ngrep () {
1147         if test -n "$GETTEXT_POISON"
1148         then
1149             : # pretend success
1150         elif test "x!" = "x$1"
1151         then
1152                 shift
1153                 ! grep "$@"
1154         else
1155                 grep "$@"
1156         fi
1157 }
1158
1159 # test whether the filesystem supports symbolic links
1160 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1161 rm -f y
1162
1163 # When the tests are run as root, permission tests will report that
1164 # things are writable when they shouldn't be.
1165 test -w / || test_set_prereq SANITY